#ifndef PACKER_H_
#define PACKER_H_

#include <string>
#include <msp/datafile/statement.h>
#include <msp/io/buffered.h>
#include <msp/io/file.h>

class DataTool;

class Packer
{
private:
	struct Object
	{
		std::string name;
		std::string keyword;
	};

	typedef std::list<Object> ObjectList;

	DataTool &tool;
	Msp::IO::BufferedFile *tmp_file;
	std::list<Msp::DataFile::Statement> directory;
	unsigned dir_alloc;

public:
	Packer(DataTool &);
private:
	static Msp::IO::BufferedFile *tempfile();
public:
	~Packer();

	void pack_file(const std::string &);
private:
	bool detect_raw(Msp::IO::Seekable &);
	void transfer_datafile(Msp::IO::Base &, const std::string &, Msp::IO::Base &, ObjectList &);
	void transfer_raw(Msp::IO::Base &, Msp::IO::Base &);
public:
	void create_pack(const std::string &);
};

#endif
